﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Nixory - antispyware tool 
## Version: 1.0.2

##Released under GNU General Public License v2


#Load modules
import pygtk, gtk, gobject, ConfigParser
pygtk.require('2.0')
from locale import getpreferredencoding
from pango import ELLIPSIZE_END
from os import stat, environ, path, listdir
from time import time
from sys import argv
from platform import system as systemname
from platform import release, mac_ver
from getpass import getuser
from activeshield import actshield

#The following is needed only for the Win executable version of Nixory
#COMMENT
#from os import chdir
#import _winreg

#Import windows
import winscan, winpreferences, wineventlog, winabout, winupdate

#Execution time
timen = time()

#Load psyco (if exists)
try:
    import psyco
    psyco.full()
except:
    print 'Psyco not present.. skipped'
else:
    print 'Psyco successfully imported'
    

class indexWindow:
    
    def __init__(self):
        
        #Win executable only: set current working directory from registry
        #COMMENT
        """
        print "Setting cwd...",
        try:
           cwdkey = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Run")
           cwdvalue = _winreg.QueryValueEx(cwdkey, "Nixory")
           cwdvalue = cwdvalue[0]
           cwdvalue = cwdvalue.replace('"','')[:-18]
           if ("/nogui" not in argv) or (not path.exists(str(cwdvalue) + "\\")) or cwdvalue == None:
               print "skipped"
           else:
               chdir(str(cwdvalue) + "\\")
               print cwdvalue
        except:
           print "skipped"
        """   
           
        print 'Loading configuration..',
        #Create configparser object
        self.globalconfig = ConfigParser.ConfigParser()
        self.globalconfig.read('etc/gconfig.cfg')
        
        print 'OK'
        print 'Loading definitions..',
        
        #Create configparser object
        self.defconfig = ConfigParser.ConfigParser()
        self.defconfig.read('etc/black_list.cfg')
        
        print 'OK'
        
        #Assign main variables
        self.nametheme = 'icons/default' #won't be edited
        
        print 'Loading language file...',
    
        #Load language file
        self.languageconfig = ConfigParser.ConfigParser()
        self.languageconfig.read('etc/lang/en/langconf.cfg')

        #Convert all strings to pygtk-utf8 encoding
        for section in self.languageconfig.sections():
            for option in self.languageconfig.options(section):
                self.languageconfig.set(section, option, self.languageconfig.get(section, option).decode(getpreferredencoding()).encode("utf-8"))

        print 'OK'
        
        #Load icons
        self.nixoryicf = gtk.IconFactory()
        self.nixoryicf.add(gtk.STOCK_DIALOG_INFO, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/info_big.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_DIALOG_ERROR, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/error_big.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_OK, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/apply.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_NO, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/deny.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_YES, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/apply.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_APPLY, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/apply.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_CLOSE, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/deny.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_CANCEL, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/deny.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_DIALOG_WARNING, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/warning.png" % self.nametheme)))
        self.nixoryicf.add_default()
        
        #Monitorate configuration files
        self.lstime = stat('etc/gconfig.cfg').st_mtime
        self.lstime2 = stat('etc/black_list.cfg').st_mtime

        #If first running, search for profiles
        if not int(self.globalconfig.get('PREFERENCES', 'search_ex')) or '-auto' in argv:
          sysname = systemname()
          
          prof = []
          
          #Firefox (Linux/Win/Mac)
          if sysname == 'Windows' or release() == 'Windows':
           pathto = environ.get('APPDATA') + '\\Mozilla\\Firefox\\Profiles\\'
           if path.exists(pathto): prof = listdir(pathto)
          elif sysname == 'Linux':
           pathto = environ.get('HOME') + '/.mozilla/firefox/' 
           if path.exists(pathto): prof = listdir(pathto)
          elif mac_ver()[0]:
           pathto = environ.get('HOME') + '/Library/Mozilla/Firefox/Profiles/'
           if not path.exists(pathto): pathto = environ.get('HOME') + '/Library/Application Support/Mozilla/Firefox/Profiles/'
           if path.exists(pathto): prof = listdir(pathto)
          #Add profiles detected
          if prof:
            for profile in prof:
              if sysname == "Windows" or release() == 'Windows': selected = pathto + str(profile) + '\\cookies.sqlite'
              else: selected = pathto + str(profile) + '/cookies.sqlite'
              if not path.exists(selected):
                pass
              else:
                  if selected not in self.globalconfig.get('USER', 'profiles'): 
                      self.globalconfig.set('USER', 'profiles', self.globalconfig.get('USER','profiles') + str(path.basename(path.dirname(selected)) + '|' + str(selected) + '|firefox|1||'))
                      print 'Detected firefox profile: ' + str(selected)
          
          #Reset
          prof = []
          
          #Chrome (Linux/Win/Mac)
          if sysname == 'Windows':
           pathto = environ.get('LOCALAPPDATA') + '\\Google\\Chrome\\User Data\\'
           if path.exists(pathto): prof = listdir(pathto)
          elif sysname == 'Linux':
           pathto = environ.get('HOME') + '/.config/google-chrome/'
           if path.exists(pathto): prof = listdir(pathto)
          elif mac_ver()[0]:
           pathto = environ.get('HOME') + '/Library/Google/Chrome/'
           if not path.exists(pathto): pathto = environ.get('HOME') + '/Library/Application Support/Google/Chrome/'
           if path.exists(pathto): prof = listdir(pathto)
          #Add profiles detected
          if prof:  
            for profile in prof:
              if sysname == "Windows" or release() == 'Windows': selected = pathto + str(profile) + '\\Cookies'
              else: selected = pathto + str(profile) + '/Cookies'
              if not path.exists(selected):
                pass
              else:
                  if selected not in self.globalconfig.get('USER', 'profiles'): 
                      self.globalconfig.set('USER', 'profiles', self.globalconfig.get('USER','profiles') + str(path.basename(path.dirname(selected)) + '|' + str(selected) + '|chrome|1||'))
                      print 'Detected chrome profile: ' + str(selected)
                      
                      
          #Reset
          prof = []
          
          #Chromium (Linux/Win/Mac)
          if sysname == 'Windows':
           pathto = environ.get('LOCALAPPDATA') + '\\Chromium\\User Data\\'
           if path.exists(pathto): prof = listdir(pathto)
          elif sysname == 'Linux':
           pathto = environ.get('HOME') + '/.config/chromium/'
           if path.exists(pathto): prof = listdir(pathto)
          elif mac_ver()[0]:
           pathto = environ.get('HOME') + '/Library/Chromium/'
           if not path.exists(pathto): pathto = environ.get('HOME') + '/Library/Application Support/Chromium/'
           if path.exists(pathto): prof = listdir(pathto)
          #Add profiles detected
          if prof:  
            for profile in prof:
              if sysname == "Windows" or release() == 'Windows': selected = pathto + str(profile) + '\\Cookies'
              else: selected = pathto + str(profile) + '/Cookies'
              if not path.exists(selected):
                pass
              else:
                  if selected not in self.globalconfig.get('USER', 'profiles'): 
                      self.globalconfig.set('USER', 'profiles', self.globalconfig.get('USER','profiles') + str(path.basename(path.dirname(selected)) + '|' + str(selected) + '|chrome|1||'))
                      print 'Detected chrome (chromium) profile: ' + str(selected)
 
 
          #Reset
          prof = []
                  
          #IE (Windows only)
          if sysname == 'Windows' or release() == 'Windows':
           selected = environ.get('APPDATA') + '\\Microsoft\\Windows\\Cookies'
           if path.exists(selected):
              if selected not in self.globalconfig.get('USER', 'profiles'):
                  name = "Default"
                  try: name = getuser()
                  except: pass
                  self.globalconfig.set('USER', 'profiles', self.globalconfig.get('USER','profiles') + name + '|' + str(selected) + '|ie|1||')
                  print 'Detected Internet Explorer profile: ' + str(selected)
         

          #Set false
          self.globalconfig.set('PREFERENCES', 'search_ex', '1')
          self.globalconfig.write(open('etc/gconfig.cfg','w'))
          
        #Show main window
        #If run with -nogui option, do not show the main window
        showgui = True
        if '/nogui' in argv:
            showgui = False
            
        self.show_tray_icon(showgui)
        actshield.setTray(self.trayicon)
        self.win_main(showgui)
        
    def show_tray_icon(self, showgui = True):
        #Show active shield tray icon
        def show_menu(widget, button, time, menu):
            #Show menu
            menu.show_all()
            if systemname() == "Windows" or release() == "Windows":  menu.popup(None, None, None, button, time) 
            else: menu.popup(None, None, positionate_menu, button, time)  
            
        def quit(*items):
            gtk.main_quit()
            
        def positionate_menu(menu, user_data=None):
            #Adjust menu position some pixels up the tray icon on the y coord
            iconpos = gtk.status_icon_position_menu(menu, self.trayicon)
            return iconpos
            
        #Define trayicon
        menu = gtk.Menu()
        if int(self.globalconfig.get('PREFERENCES', 'prog_check')) or not showgui:
            #The user requested to run active shield now
            actshield.start()
            self.trayicon = gtk.status_icon_new_from_file('%s/nixory_tray.png' % self.nametheme)
            if int(self.globalconfig.get("PREFERENCES", "show_tooltip")): tooltip = "Running:  %s Objects cleaned" % self.globalconfig.get("GENERAL", "shield_cleaned")
            else: tooltip = "Nixory active shield running"
            self.trayicon.set_tooltip(tooltip)
        else:
            self.trayicon = gtk.status_icon_new_from_file('%s/nixory_tray_inactive.png' % self.nametheme)
            self.trayicon.set_tooltip('Nixory active shield not running')
            if int(self.globalconfig.get('PREFERENCES','hide_icon')): self.trayicon.set_visible(False)
        
        
        self.trayicon.connect('popup-menu',show_menu,menu)
        self.trayicon.connect('activate', self.win_showhide)
        
        #Build menu
        #Menu item show menu
        item = gtk.ImageMenuItem('Show interface')
        itemimg = gtk.image_new_from_stock(gtk.STOCK_REDO, gtk.ICON_SIZE_MENU)  
        item.set_image(itemimg)
        item.connect('activate', self.win_showhide)
        menu.append(item)
        
        #Menu separator
        item = gtk.SeparatorMenuItem()  
        menu.append(item)
        
        #Menu item quit
        item = gtk.ImageMenuItem('Quit')
        itemimg = gtk.image_new_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_MENU)  
        item.set_image(itemimg)
        item.connect('activate', self.quit_all)
        menu.append(item)
    
    def win_showhide(self, *items):
        #if window is running do nothing
        self.win.show_all()
    
    def win_main(self, show, *items):
        #Construct main window
        self.win = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.connect("delete_event", self.win.hide_on_delete)
        #self.win.connect("destroy",self.destroywin, self.win)
        self.win.set_position(gtk.WIN_POS_CENTER)
        self.win.set_default_size(550, 316)
        self.win.set_resizable(True)
        self.win.set_title('Nixory')
        gtk.window_set_default_icon_from_file('%s/nixory_icon.png' % self.nametheme)
        self.win.connect("focus-in-event", self.event_occ, self)
                
        #Table container
        indextable = gtk.Table(4, 3, False)
        
        #HBox container
        buttonsbox = gtk.HBox(False, 0)
        
        #Tree liststore
        global liststore
        liststore = gtk.ListStore(gtk.gdk.Pixbuf, int, str)
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/scans.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_scans')), self.languageconfig.get('MAINWINDOW','index_scan')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/found_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_found_obj')), self.languageconfig.get('MAINWINDOW','index_found_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/removed_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_removed_obj')), self.languageconfig.get('MAINWINDOW','index_removed_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/tracking_cookie.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_tracking')), self.languageconfig.get('MAINWINDOW','index_tracking')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/p_tracking_cookie.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_tracking_p')), self.languageconfig.get('MAINWINDOW','index_tracking_p')])        
        
        #TreeView
        treeview = gtk.TreeView(liststore)
        treeview.set_rules_hint(True)
    
        #TreeViewColums
        columnint = gtk.TreeViewColumn(' '*12)
        columnint.set_resizable(True)
        columnstr = gtk.TreeViewColumn(self.languageconfig.get('MAINWINDOW','index_name'))
    
        #Append columns
        treeview.append_column(columnint)
        treeview.append_column(columnstr)
    
        #Cellrenderers
        cellpix = gtk.CellRendererPixbuf()
        cellint = gtk.CellRendererText()
        cellstr = gtk.CellRendererText()
        cellstr.set_property('ellipsize-set', True)
        cellstr.set_property('ellipsize', ELLIPSIZE_END)
    
        #Add cell renderers
        columnint.pack_start(cellpix, True)
        columnint.pack_start(cellint, True)
        columnstr.pack_start(cellstr, True)
    
        #Set attributes
        columnint.set_attributes(cellpix, pixbuf=0)
        columnint.set_attributes(cellint, text=1)
        columnstr.set_attributes(cellstr, text=2)
        cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
        #Status Bar
        global nixstatusbar
        nixstatusbar = gtk.Statusbar()
        nixstatusbar.push(1, (':'*3) + self.languageconfig.get('MAINWINDOW','database_status') + ' ' + self.defconfig.get('INFO','version'))
        
        #Box button quit
        quitbox = gtk.HBox(False, 0)
        quitimage = gtk.Image()
        quitimage.set_from_file('%s/quit.png' % self.nametheme)
        quitlab = gtk.Label('   %s' % self.languageconfig.get('MAINWINDOW','quit_label') + "  ")
        quitbox.pack_start(quitimage, False, 1)
        quitbox.pack_start(quitlab, True, 1)
        quitbut = gtk.Button()
        quitbut.add(quitbox)
        quitbut.connect('clicked', self.destroywin, self.win)

        #Box button active shield
        shieldbox = gtk.HBox(False, 0)
        shieldimage = gtk.Image()
        shieldimage.set_from_file('%s/active_shield.png' % self.nametheme)
        shieldlab = gtk.Label('   %s' % self.languageconfig.get('MAINWINDOW','shield_label'))
        shieldbox.pack_start(shieldimage, False, 1)
        shieldbox.pack_start(shieldlab, True, 1)
        shieldbut = gtk.Button()
        shieldbut.add(shieldbox)
        shieldbut.connect('clicked',  winpreferences.winshow, self.destroywin, self.delete_event, self.languageconfig, self.globalconfig, self.nametheme, self.win, True, self.trayicon)
    
        #Button Scan
        scanbox = gtk.HBox(False, 0)
        scanimage = gtk.Image()
        scanimage.set_from_file('%s/scan_now.png' % self.nametheme)
        scanlab = gtk.Label('  %s' % self.languageconfig.get('MAINWINDOW','scan_label'))
        scanbox.pack_start(scanimage, False, 1)
        scanbox.pack_start(scanlab, True, 1)
        scanbut = gtk.Button()
        scanbut.add(scanbox)
        scanbut.connect('clicked', winscan.winshow, self.destroywin, self.delete_event, self.languageconfig, self.globalconfig, self.defconfig, self.nametheme, self.win)      

        #Label
        status = gtk.Label()
        status.set_text(self.languageconfig.get('MAINWINDOW','status_label'))
    
        #box packstart
        buttonsbox.pack_start(quitbut, False, 1)
        buttonsbox.pack_start(shieldbut, False, 1)
        buttonsbox.pack_start(scanbut, False, 1)
    
        #File menu
        file_menu = gtk.Menu()
    
        #Add quit item
        quit_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_file_quit'))
        image = gtk.Image()
        image.set_from_file('%s/quit.png' % self.nametheme)
        quit_item.set_image(image)
        quit_item.connect_object('activate', self.destroywin, self.win)
    
        file_menu.append(quit_item)
    
        #Options menu
        options_menu = gtk.Menu()
    
        #Add configure item
        configure_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_preferences'))
        configure_image = gtk.Image()
        configure_image.set_from_file('%s/preferences.png' % self.nametheme) 
        configure_item.set_image(configure_image)
        configure_item.connect('activate', winpreferences.winshow, self.destroywin, self.delete_event, self.languageconfig, self.globalconfig, self.nametheme, self.win, False, self.trayicon)

        options_menu.append(configure_item)
    
        #Actions menu
        act_menu = gtk.Menu()
    
        #Add scan item
        scan_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_scan'))
        scan_image = gtk.Image()
        scan_image.set_from_file('%s/scan_now.png' % self.nametheme)
        scan_item.set_image(scan_image)
        scan_item.connect('activate', winscan.winshow, self.destroywin, self.delete_event, self.languageconfig, self.globalconfig, self.defconfig, self.nametheme, self.win)
    
    
        #Add eventlog item
        evlog_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_eventlog'))
        evlog_image = gtk.Image()
        evlog_image.set_from_file('%s/eventlog.png' % self.nametheme)
        evlog_item.set_image(evlog_image)
        evlog_item.connect('activate', wineventlog.winshow, self.destroywin, self.delete_event, self.languageconfig, self.nametheme, self.win)
    
        act_menu.append(scan_item)
        act_menu.append(evlog_item)
    
        #Help menu
        help_menu = gtk.Menu()
        
        #Add updates item
        upd_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_upd'))
        upd_image = gtk.Image()
        upd_image.set_from_file('%s/upd.png' % self.nametheme)
        upd_item.set_image(upd_image)
        upd_item.connect('activate', winupdate.winshow, self.destroywin, self.delete_event, self.globalconfig, self.nametheme, self.win)
    
        #Add about item
        about_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_about'))
        about_image = gtk.Image()
        about_image.set_from_file('%s/info.png' % self.nametheme)
        about_item.set_image(about_image)
        about_item.connect('activate', winabout.winshow, self.destroywin, self.delete_event, self.languageconfig, self.nametheme, self.win)
    
        help_menu.append(upd_item)
        help_menu.append(about_item)
    
        #Add menus
        menu_bar = gtk.MenuBar()
    
        file_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_file'))
        file_item.set_submenu(file_menu)
    
        options_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_options'))
        options_item.set_submenu(options_menu)
    
        act_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_act'))
        act_item.set_submenu(act_menu)
    
        about_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_help'))
        about_item.set_submenu(help_menu)
    
        menu_bar.append(file_item)
        menu_bar.append(options_item)
        menu_bar.append(act_item)
        menu_bar.append(about_item)
    
    
        #show
        indextable.attach(menu_bar, 0, 3, 0, 1, gtk.FILL, gtk.FILL)
        indextable.attach(treeview, 0, 3, 1, 2, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
        indextable.attach(buttonsbox, 0, 1, 2, 3, 0 , 0)
        indextable.attach(status, 1, 3, 2, 3, gtk.EXPAND|gtk.FILL , 0)
        indextable.attach(nixstatusbar, 0, 3, 3, 4, gtk.FILL, gtk.FILL)
        self.win.add(indextable)
        if show: self.win.show_all()
    
        #Focus
        self.win.set_focus(None)

        #Print execution time
        if '-debug' in argv:
            print 'Executed in ' + str(time() - timen) + ' seconds'
        
    def event_occ(self, widget, event, *items):
        #If global configuration has changed, update it
        if not stat('etc/gconfig.cfg').st_mtime == self.lstime:
            self.lstime = stat('etc/gconfig.cfg').st_mtime
            self.globalconfig.read('etc/gconfig.cfg')
            #print 'Updated gconfig!'

            #Update stat list
            global liststore, globalconfig
            liststore.set_value(liststore.get_iter(0), 1, int(self.globalconfig.get('GENERAL','num_scans')))
            liststore.set_value(liststore.get_iter(1), 1, int(self.globalconfig.get('GENERAL','num_found_obj')))
            liststore.set_value(liststore.get_iter(2), 1, int(self.globalconfig.get('GENERAL','num_removed_obj')))
            liststore.set_value(liststore.get_iter(3), 1, int(self.globalconfig.get('GENERAL','num_tracking')))
            liststore.set_value(liststore.get_iter(4), 1, int(self.globalconfig.get('GENERAL','num_tracking_p')))
            
        if not stat('etc/black_list.cfg').st_mtime == self.lstime2:
            self.lstime2 = stat('etc/black_list.cfg').st_mtime
            self.defconfig.read('etc/black_list.cfg')
            nixstatusbar.push(1, (':'*3) + self.languageconfig.get('MAINWINDOW','database_status') + ' ' + self.defconfig.get('INFO','version'))
            #print 'Updated black list!'
        
    
    def main(self):
        gtk.main()
        
    def delete_event(self, widget, event, data=None):
        return False
    
    def show_warning(self, *items):
        #Input Dialog
        inputd = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, None)
        inputd.set_title("Notification")
        inputd.set_modal(False)
        inputd.set_position(gtk.WIN_POS_CENTER)
        inputd.format_secondary_markup("Note: Nixory active shield will remain active in system tray.")
        
        #Content
        entry = gtk.CheckButton("Do not show me again")
        
        #Hbox
        hbox = gtk.HBox()
        hbox.pack_start(entry)
        inputd.vbox.pack_end(hbox, True, True, 0)
        inputd.show_all()
        resp = inputd.run()
        if resp == gtk.RESPONSE_OK:
            if entry.get_active(): 
                self.globalconfig.set("PROGRAM","do_show", "0")
                self.globalconfig.write(open("./etc/gconfig.cfg","w"))
            inputd.destroy()
        inputd.destroy()
        
    def destroywin(self, widget, window=None):
        print "Closing interface...",
        if self.win:
            self.win.hide()
        
        #If active shield is not running, terminate thread
        if not actshield.isRunning and actshield.thread.isAlive():
            if self.trayicon.get_visible(): self.trayicon.set_visible(False)
            actshield.stop()
            actshield.terminate()
            actshield.thread.join(10.0) #Wait up to 10 seconds
            if actshield.thread.isAlive(): print "Warning:: could not stop active shield thread" #Hopefully this will not happen...
            gtk.main_quit() #Quit anyway
            
        #If active shield is running, just hide the main window (If we quit gtk we would kill the trayicon as well)
        elif actshield.isRunning and bool(int(self.globalconfig.get("PROGRAM","do_show"))):
            #Warn the user
                self.show_warning()
        print "OK"
        
        
    def quit_all(self, *items):
        #Quit interfance AND shield
        if self.win:
            print "Closing interface...",
            self.win.hide()
            if self.trayicon.get_visible(): self.trayicon.set_visible(False)
            print "OK"
            
        print "Terminating active shield...",    
        actshield.stop()
        actshield.terminate()
        actshield.thread.join(10.0) #Wait up to 10 seconds
        if actshield.thread.isAlive(): print "Warning:: could not stop active shield thread" #Hopefully this will not happen...
        else: print "OK"
        gtk.main_quit() #Quit

if __name__ == '__main__':
    #Start main application
    loop = indexWindow()
    loop.main()